function [ minIC,minoperatingannual ] = functionLG( length,Qtot,Tnetwork,MQgeo,massflow,elprice,maintenance)

%Lizeta!

%Input 1: pipe length (m) of network. This is the distance that our pipes are
%required to travel, in order to cover heat demand in a specific
%city/university
%length=9408.267938;

%Input 2. Set the demand Qtot you are covering (MW). This is the peak load
%at your design temperature.
%Qtot=28.2;

%Input 3. Set the temperature of the network. You can choose between 90C and
%140C, basically choose between 90,95,100,...,140C. (keep step=5)
%Tnetwork=90;

%input 4: set the price of electricity (for pumping needs), $/kWh
%elprice=0.07;

%input 5: set the maintenance cost. $/Mwh delivered
%maintenance=3;


%(don't modify this..it refers to cornell peak consumption)
%Qcornell=28.2;

%input 7:If you want, set yearly load (MWh). The simplest thing you can do is just let it scale
%it according to Cornell.

%MQgeo=(Qtot/Qcornell)*69493;

%For Cornell: Average temperature: 9C. Minimum temperature -18C. (This is
%for reference, for later modifications)


%

%calculate the ratio of heat demand, relatively to cornell in order to assign the according mass
%flow
%KV inputs massflow!! This is a matrix of size 365*1
mf=massflow;


density=943;
%4-16in diameter (2-8in radius) of pipes. Basically this allows selection relatively to
%mass flow.
r=linspace(2,8,13);


%thresshold for pipe diameter calculation

%find the minimum radius, when installing one pipe. From excel: diameter(maximum) =
%1.5197*massflow^0.427. When radius reaches 6in (diameter=12in),
%extrapolate linearly to find the according diameter.


g=9.81;
spweight=density*g;
%assume 60% efficiency for pump;
efficiency=0.6;
%Re>10^6 ..turbulent flow
fmoody=0.027;
velocity=zeros(365,13);
hf=zeros(365,13);
DP=zeros(365,13);
PP=zeros(365,13);
ShaftP=zeros(365,13);
Energy=zeros(13,1);
rinminimum=zeros(50,1);
%This model allows installation up to 50 pipes. We can add more-if
%reasonable.


%first find the maximum flow

    mfmax=0;
for i=1:365
    if mfmax<mf(i)
    mfmax=mf(i);
    else
    end
end



for i=1:50
    if mfmax>(106.4647*i)
        rinminimum(i)=0.5*(5.5726+0.062183*((1/i)*mfmax));
        
        else
        
    rinminimum(i)=0.5*(1.5197*((1/i)*mfmax)^0.427);
    end
end
    

pipenumber=zeros(13,1);
for k=1:13
    for i=1:365
        for h=1:50
            %find the number of pipes you should install
            %if the selected radius is above the limiting factor, then put
            %h number of pipes. 
              
        if r(k)>rinminimum(h)
            %install h pipes
  velocity(i,k)=mf(i)/(h*density*pi()*((r(k)*0.0254)^2));
  hf(i,k)=fmoody*(length/((r(k)*0.0254)*2))*(velocity(i,k)^2)/(2*g);
  DP(i,k)=spweight*hf(i,k);
  %http://h240.marcks.cc/downloads/02_control_valves.pdf 
  %==>We can assume that
  %valve authority 0.3 ==>Pressure drop across the valve/Total pressure
  %drop=0.3 ==>Total pressure loss=10/7*pressure loss in pipes
  
  PP(i,k)=(DP(i,k)*mf(i)/density)*(10/7);
  %Now find the total loss (all pipes)
  
  ShaftP(i,k)=h*PP(i,k)/efficiency;
  %we have daily data so the output ShaftP(W) must be multiplied by 24 to
  %derive the daily consumption (Wh)
  Energy(k)=Energy(k)+24*ShaftP(i,k);
  %keep the number of pipes you have selected to install
  pipenumber(k)=h;
  
  %now stop the for-loop since you don't want to install more than needed
  break
       
        end
        %ok, now for very small pipe diameter, when you have very high mass
        %flow, you should take into account that you can't install for example 2in
        %radius..
        if r(k)<rinminimum(50)
            %report as infinite power needed
            Energy(k)=10^20;
            ShaftP(i,k)=10^20;
        end
        end
    end
end


MWH=Energy/1000000;
%total pumping cost
pumpingcost=MWH*elprice*1000;

PC=zeros(1,13);
for j=1:13
    
PC(j)=pumpingcost(j)/MQgeo;
end


%pumping investment cost
%assume that cost varies proportionally to power output (kW)
%for 800kW purchased cost 30,000$==>with f=3.5: 120000$. No further data for 
%pumping cost function with capacity in Perry's, so assume linear scaling up/down

%find maximum power needed by the pump. 
Shaftmax=zeros(13,1);

for j=1:13
    Shaftmax(j)=0;
for i=1:365
    if Shaftmax(j)<ShaftP(i,j)
    Shaftmax(j)=ShaftP(i,j);
    else
    end
end
end



Pneeded=Shaftmax;
%calculate investment cost of pump according to its capacity. scale up/down.
PumpIC=(Pneeded/800000)*120000;


%distribution cost variations according to pipe diameter (corrected)
%y=92.435x + 284.77
Cdist=zeros(13,1);
for i=1:13
  if pipenumber(i)==1
      %install one pipe
     Cdist(i)=length*(92.435*(r(i)*2) + 284.77); 
  elseif pipenumber(i)<6
     %that's just a simplification. We are not really sure how many times we are going to account for paving costs    
Cdist(i)=(pipenumber(i)-(pipenumber(i)-2)*0.1945)*length*(92.435*(r(i)*2) + 284.77); 
  else
Cdist(i)=(pipenumber(i)-(pipenumber(i)-3)*0.1945)*length*(92.435*(r(i)*2) + 284.77); 
  end


end



%now find the total investment cost, consisting of pumps and piping costs.
totalcost=zeros(13,1);


totalcost(:,1)=Cdist(:,1)+(PumpIC(:,1));


   
    %optimization loop. set an arbitrary value for minimum investment cost.
    %At! optimization only according to Investment cost
minIC=10000000000000;
    for i=1:13
        if minIC>totalcost(i)
        minIC=totalcost(i);
        minoperating=(maintenance+PC(i));
        roptimum=r(i);
        %lcohoptimum=dolperkwhheat(i);
        numberoptimum=pipenumber(i);
        else
        end
    end
 
   minoperatingannual=minoperating*MQgeo; 

end


